#define _XOPEN_SOURCE 700
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <stdbool.h>
#include <string.h>
#include <sys/types.h>
#include <utime.h>

void CHECK(bool expr, const char *msg)
{
    if (!expr)
    {
        perror(msg);
        exit(1);
    }
}

int main(int argc, char **argv) {
    CHECK(3 == argc, "argc");
    
    struct stat finfo;
    CHECK(-1 != stat(argv[1], &finfo), "stat");
    CHECK(S_ISDIR(finfo.st_mode), "s_isdir");
    
    const char *fname = strrchr(argv[1], '/');
    if (NULL == fname)
    {
        CHECK(-1 != rename(argv[1], argv[2]), "rename");
    }
    else 
    {
        int base = fname - argv[1] + 1;
        char *newPath = malloc(base + strlen(argv[2]) + 1);
        CHECK(newPath, "malloc");
        strncpy(newPath, argv[1], base);
        strcat(newPath, argv[2]);
        
        CHECK(-1 != rename(argv[1], newPath), "rename");
        free(newPath);
    }
    
    return 0;
}
