#define _XOPEN_SOURCE 700
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <stdbool.h>
#include <string.h>
#include <sys/types.h>
#include <utime.h>

void CHECK(bool expr, const char *msg)
{
    if (!expr)
    {
        perror(msg);
        exit(1);
    }
}

int main(int argc, char **argv) {
    CHECK(2 == argc, "argc");
    
    struct stat finfo;
    CHECK(-1 != stat(argv[1], &finfo), "stat");
    
    mode_t user = finfo.st_mode & S_IRWXU;
    mode_t group = finfo.st_mode & S_IRWXG;
    mode_t others = finfo.st_mode & S_IRWXO;
    mode_t result = user | (group >> 3) | (others << 3);
    
    CHECK(-1 != chmod(argv[1], result), "chmod");
   
    return 0;
}
