#define _XOPEN_SOURCE 700
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <stdbool.h>
#include <string.h>
#include <sys/types.h>
#include <utime.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <dirent.h>

void CHECK(bool expr, const char *msg)
{
    if (!expr)
    {
        perror(msg);
        exit(1);
    }
}

void osMinMaxSize(const char *fpath, unsigned *pMinSize, unsigned *pMaxSize)
{
    struct stat finfo;
    CHECK(-1 != lstat(fpath, &finfo), "lstat");
    
    if (S_ISREG(finfo.st_mode))
    {
        if (finfo.st_size < *pMinSize)
            *pMinSize = finfo.st_size;
        if (finfo.st_size > *pMaxSize)
            *pMaxSize = finfo.st_size;
    }
    
    if (S_ISDIR(finfo.st_mode))
    {
        DIR *dir = opendir(fpath);
        CHECK(dir, "opendir");
        CHECK(-1 != chdir(fpath), "chdir");
        struct dirent *entry = NULL;
        while (entry = readdir(dir))
        {
            if (!strcmp(".", entry->d_name) || !strcmp("..", entry->d_name))
                continue;
            
            osMinMaxSize(entry->d_name, pMinSize, pMaxSize);
        }
        
        CHECK(-1 != chdir(".."), "chdir ..");
        CHECK(-1 != closedir(dir), "closedir");
    }
}

int main(int argc, char **argv) {
    CHECK(2 == argc, "argc");
    
    unsigned minSize = 0XFFFFFFFFU;
    unsigned maxSize = 0;
    
    struct stat finfo;
    CHECK(-1 != lstat(argv[1], &finfo) && S_ISDIR(finfo.st_mode), "wrong program argument");
    
    osMinMaxSize(argv[1], &minSize, &maxSize);
    printf("%u\n", maxSize - minSize);
    return 0;
}
