#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <stdbool.h>

#include <limits.h>
#include <string.h>

int main(int argc, char** argv) {
	
	if (argc == 1) {
		exit(EXIT_FAILURE);
	}
	
	int i = 0;
	for (i = 1; i < argc; i++) {
		
		struct stat fInfo;
		if (stat(argv[i], &fInfo) == -1) {
			exit(EXIT_FAILURE);
		}
		
		if (!S_ISDIR(fInfo.st_mode)) {
			exit(EXIT_FAILURE);
		}
		
		if (!(fInfo.st_mode & S_IROTH) && !(fInfo.st_mode & S_IWOTH) && !(fInfo.st_mode & S_IXOTH)) {
			
			char* path = realpath(argv[i], NULL);
			
			if (path == NULL) {
				exit(EXIT_FAILURE);
			}
			
			printf("%d\n", (int)strlen(path));
			
			free(path);
		}
	}
	
	
	exit(EXIT_SUCCESS);
}
