#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <stdbool.h>

#include <string.h>
#include <ftw.h>

char* fileExt;

int processFile(const char* fpath, const struct stat *sb, int typeflag, struct FTW* ftwbuf){
	
	if (typeflag == FTW_F){
		
		if (ftwbuf->level >= 2 && ftwbuf->level <= 5) {
			
			char* ext = strrchr(fpath, '.');
			if (ext != NULL && !strcmp(ext, fileExt)) {
				printf("%s\n", fpath + ftwbuf->base);
			}
		}
	}
	
	return 0;
}

int main(int argc, char** argv) {
	
	if (argc != 3) {
		exit(EXIT_FAILURE);
	}
	
	fileExt = argv[2];
	
	struct stat fInfo;
	if (stat(argv[1], &fInfo) == -1){
		exit(EXIT_FAILURE);
	}
	
	if (!S_ISDIR(fInfo.st_mode)){
		exit(EXIT_FAILURE);
	}
	
	if (nftw(argv[1], processFile, 50, 0) == -1) {
		exit(EXIT_FAILURE);
	}
	
	exit(EXIT_SUCCESS);
}
